<?php

namespace Modules\Cotacao\Modules\ListaPreco\Services;

use Doctrine\ORM\EntityManager;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class Sup01200MontagemListaPrecoService
{
    protected $crudService;
    protected $entityManager;
    protected $environment;
    protected $connection;

    public function __construct($crudService, $entityManager, $environment, $connection)
    {
        $this->crudService       = $crudService;
        $this->entityManager     = $entityManager;
        $this->environment       = $environment;
        $this->connection        = $connection;
    }

    public function updatePrevLista($row)
    {
        try {
            $query = "UPDATE PREVLISTA 
                         SET DTCOMPPREV   = SYSDATE, 
                             IDDISPLISFIL = 'N', 
                             IDATUCUSLIST = 'S', 
                             IDPREVSELLIS = 'N', 
                             IDSTATUSPRLIST  = 'I', 
                             IDSTATUSANTLIST = 'I' 
                       WHERE CDFILIAL     = :P_CDFILIAL
                         AND NRSEQPRELIST = :P_NRSEQPRELIST
                         AND NRORG        = :P_NRORG";

            $params = array(
                "P_CDFILIAL"     => $row['P_CDFILIAL'],
                "P_NRSEQPRELIST" => $row['P_NRSEQPRELIST'],
                "P_NRORG"        => $this->environment->getNrOrg()
            );

            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function insertPrevlista($row)
    {
        try {
            $query = "INSERT INTO PREVLISTA (CDFILIAL, 
                                             NRSEQPRELIST, 
                                             DTCOMPPREV, 
                                             CDOPERADOR, 
                                             DTINIVALLIST, 
                                             DTFINVALLIST, 
                                             IDATUCUSLIST, 
                                             IDDISPLISFIL, 
                                             CDPRODINILIST, 
                                             CDPRODFINLIST, 
                                             IDCOTSEMMOVLIST, 
                                             IDCOINVALIDLIST, 
                                             IDSTATUSPRLIST,
                                             NRORG) 
                                     VALUES (:P_CDFILIAL, 
                                             :P_NRSEQPRELIST, 
                                             SYSDATE, 
                                             :P_CDOPERADOR, 
                                             TO_DATE(:P_DTINIVALLIST), 
                                             TO_DATE(:P_DTFINVALLIST), 
                                             'S', 
                                             'N', 
                                             :P_CDARVPRODINI, 
                                             :P_CDARVPRODFIN, 
                                             :P_IDCOTSEMMOVLIST, 
                                             :P_IDCOINVALIDLIST, 
                                             'I',
                                             :P_NRORG)";
            $params = array(
                "P_CDFILIAL"        => $row['P_CDFILIAL'],
                "P_NRSEQPRELIST"    => $row['P_NRSEQPRELIST'],
                "P_CDOPERADOR"      => $row['P_CDOPERADOR'],
                "P_DTINIVALLIST"    => $row["P_DTINIVALCOL"],
                "P_DTFINVALLIST"    => $row["P_DTFINVALCOL"],
                "P_CDARVPRODINI"    => $row["P_CDARVPRODINI"],
                "P_CDARVPRODFIN"    => $row["P_CDARVPRODFIN"],
                "P_IDCOTSEMMOVLIST" => $row['P_IDCOTSEMMOVLIST'],
                "P_IDCOINVALIDLIST" => $row["P_IDCOINVALIDLIST"],
                "P_NRORG"           => $this->environment->getNrOrg()
            );
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function insertItmprevlist($row, $regiao)
    {
        try {
            $query = "INSERT INTO ITMPREVLIST (CDFILIAL, NRSEQPRELIST, NRCOLEPRECO, CDFORNECED, CDREGIAO, CDPRODUTO, CDMARCA, IDITMSELLIS, CDFORMPGTO, VRPRECUNIIPL, VRPRECECOIPL, VRPRECOIPLPI, NRORG)
                                       (SELECT ITEMCOLE.CDFILIAL, :P_NRSEQPRELIST, ITEMCOLE.NRCOLEPRECO, ITEMCOLE.CDFORNECED, ITEMCOLE.CDREGIAO, ITEMCOLE.CDPRODUTO, ITEMCOLE.CDMARCA, NVL(ITMPREVLIST.IDITMSELLIS,'N'), ITEMCOLE.CDFORMPGTO, ITEMCOLE.VRPRECUNIITM, ITEMCOLE.VRPRECECOITM, ITEMCOLE.VRPRECOITMPI, ITEMCOLE.NRORG
                                          FROM COLETAPR INNER JOIN ITEMCOLE ON COLETAPR.CDFILIAL = ITEMCOLE.CDFILIAL AND COLETAPR.NRCOLEPRECO = ITEMCOLE.NRCOLEPRECO
                                                        INNER JOIN PRODUTO ON ITEMCOLE.CDPRODUTO = PRODUTO.CDPRODUTO
                                                         LEFT JOIN ITMPREVLIST ON ITEMCOLE.CDFILIAL    = ITMPREVLIST.CDFILIAL
                                                                              AND ITEMCOLE.NRCOLEPRECO = ITMPREVLIST.NRCOLEPRECO
                                                                              AND ITEMCOLE.CDFORNECED  = ITMPREVLIST.CDFORNECED
                                                                              AND ITEMCOLE.CDREGIAO    = ITMPREVLIST.CDREGIAO
                                                                              AND ITEMCOLE.CDPRODUTO   = ITMPREVLIST.CDPRODUTO
                                                                              AND ITEMCOLE.CDMARCA     = ITMPREVLIST.CDMARCA
                                                                              AND :P_NRSEQPRELIST      = ITMPREVLIST.NRSEQPRELIST
                                         WHERE COLETAPR.CDFILIAL   = :P_CDFILIAL
                                           AND COLETAPR.CDOPERADOR = :P_CDOPERADOR
                                           AND ITEMCOLE.CDREGIAO   = :P_CDREGIAO
                                           AND ITEMCOLE.NRORG      = :P_NRORG ";
            if ($row['P_IDCOINVALIDLIST'] === 'S') {
                $query = $query . "AND ITEMCOLE.DTINIVALITM = :P_DTINI
                                   AND ITEMCOLE.DTFINVALITM = :P_DTFIN ";
            } else {
                $query = $query . "AND ITEMCOLE.DTINIVALITM <= :P_DTFIN
                                   AND ITEMCOLE.DTFINVALITM >= :P_DTINI ";
            }

            $params = array(
                "P_NRSEQPRELIST"    => $row["P_NRSEQPRELIST"],
                "P_CDFILIAL"        => $row["P_CDFILIAL"],
                "P_CDOPERADOR"      => $row["P_CDOPERADOR"],
                "P_CDREGIAO"        => $regiao,
                "P_DTINI"           => $row["P_DTINIVALCOL"],
                "P_DTFIN"           => $row["P_DTFINVALCOL"],
                "P_NRORG"           => $this->environment->getNrOrg()
            );

            if ($row['P_TPRODUTO'] !== 'T') {
                $query = $query . "AND PRODUTO.CDARVPROD BETWEEN :P_CDARVPRODINI AND :P_CDARVPRODFIN ";
                $params = array_merge($params, array(
                    "P_CDARVPRODINI" => $row["P_CDARVPRODINI"],
                    "P_CDARVPRODFIN" => $row["P_CDARVPRODFIN"]
                ));
            }

            if ($row['P_IDCOTSEMMOVLIST'] !== 'S') {
                $query = $query . "AND COLETAPR.IDTIPCOLREG IN ('G','W', 'E') ";
            }

            $query = $query . "AND COLETAPR.IDDISMONTLIS != 'N'
                               AND ITEMCOLE.VRPRECUNIITM > 0
                               AND NOT EXISTS (SELECT 1
                                                 FROM ITMPREVLIST IT
                                                WHERE IT.CDFILIAL     = ITMPREVLIST.CDFILIAL              
                                                  AND IT.NRCOLEPRECO  = ITMPREVLIST.NRCOLEPRECO  
                                                  AND IT.CDFORNECED   = ITMPREVLIST.CDFORNECED
                                                  AND IT.CDREGIAO     = ITMPREVLIST.CDREGIAO                                   
                                                  AND IT.CDPRODUTO    = ITMPREVLIST.CDPRODUTO     
                                                  AND IT.CDMARCA      = ITMPREVLIST.CDMARCA
                                                  AND IT.NRSEQPRELIST = ITMPREVLIST.NRSEQPRELIST)
                               AND NOT EXISTS (SELECT 1
                                                 FROM REFOREG
                                                WHERE ITEMCOLE.CDREGIAO   = REFOREG.CDREGIAO 
                                                  AND ITEMCOLE.CDFORNECED = REFOREG.CDFORNECED) 
                               AND EXISTS (SELECT 1
                                             FROM PRODCOMP INNER JOIN PRODUTO PR ON PRODCOMP.CDPRODUTO = PR.CDPRODUTO
                                            WHERE PRODCOMP.CDOPERADOR = COLETAPR.CDOPERADOR 
                                              AND PRODUTO.CDARVPROD LIKE PR.CDARVPROD || '%'))";

            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function deleteItmprevlistNotExists($row)
    {
        try {
            $query = "DELETE FROM ITMPREVLIST
                       WHERE CDFILIAL     = :P_CDFILIAL
                         AND NRSEQPRELIST = :P_NRSEQPRELIST
                         AND NRORG        = :P_NRORG
                         AND NOT EXISTS(SELECT 1
                                          FROM COLETAPR
                                         WHERE COLETAPR.IDDISMONTLIS != 'N' 
                                           AND COLETAPR.CDFILIAL    = ITMPREVLIST.CDFILIAL 
                                           AND COLETAPR.NRCOLEPRECO = ITMPREVLIST.NRCOLEPRECO)";
            $params = array(
                "P_CDFILIAL"     => $row["P_CDFILIAL"],
                "P_NRSEQPRELIST" => $row["P_NRSEQPRELIST"],
                "P_NRORG"        => $this->environment->getNrOrg()
            );
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function deleteItmprevlist($row)
    {
        try {
            $query = "DELETE FROM ITMPREVLIST 
                       WHERE CDFILIAL     = :P_CDFILIAL 
                         AND NRSEQPRELIST = :P_NRSEQPRELIST
                         AND NRORG        = :P_NRORG";
            $params = array(
                "P_CDFILIAL"     => $row['P_CDFILIAL'],
                "P_NRSEQPRELIST" => $row['P_NRSEQPRELIST'],
                "P_NRORG"        => $this->environment->getNrOrg()
            );

            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function updateItemcole($row)
    {
        try {
            $query = "UPDATE ITEMCOLE SET IDITMLISPREC    = 'N',
                                          IDPRECALT       = 'N', 
                                          IDITVALDIFLISTA = 'N', 
                                          NRSEQPRELIST    = NULL 
                      WHERE CDFILIAL     = :P_CDFILIAL 
                        AND NRSEQPRELIST = :P_NRSEQPRELIST
                        AND NRORG        = :P_NRORG";

            $params = array(
                "P_CDFILIAL"     => $row['P_CDFILIAL'],
                "P_NRSEQPRELIST" => $row['P_NRSEQPRELIST'],
                "P_NRORG"        => $this->environment->getNrOrg()
            );

            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function deletePrevlist($row)
    {
        try {
            $query = "DELETE PREVLISTA 
                       WHERE CDFILIAL     = :P_CDFILIAL 
                         AND NRSEQPRELIST = :P_NRSEQPRELIST
                         AND NRORG        = :P_NRORG";

            $params = array(
                "P_CDFILIAL"     => $row['P_CDFILIAL'],
                "P_NRSEQPRELIST" => $row['P_NRSEQPRELIST'],
                "P_NRORG"        => $this->environment->getNrOrg()
            );

            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
}
